Index: trunk/src/lib/graphics/importer/height_map.h
===================================================================
--- trunk/src/lib/graphics/importer/height_map.h	(revision 7464)
+++ trunk/src/lib/graphics/importer/height_map.h	(revision 7466)
@@ -11,4 +11,6 @@
    ### File Specific:
    main-programmer: bottac@ee.ethz.ch
+
+   review: patrick boenzli, patrick@orxonox.ethz.ch
 */
 
@@ -28,89 +30,101 @@
 class HeightMap;
 
+
+//!< one part of the height map
 class Tile
 {
-public:
-void draw();
-void drawHighRes();
-void drawLowRes();
-int getRes();
-int setHighRes(bool b);
-Tile(int i1, int j1, int i2, int j2, HeightMap* hm ) ;
-Tile();
-float x;
-float z;
-virtual ~Tile();
+  public:
+    Tile();
+    Tile(int i1, int j1, int i2, int j2, HeightMap* hm) ;
+    virtual ~Tile();
+
+    int getRes();
+    int setHighRes(bool b);
+
+    void draw();
+    void drawHighRes();
+    void drawLowRes();
 
 
+  private:
+    void load(int i1, int j1, int i2, int i2, HeightMap* hm, VertexArrayModel* model, int Res);
 
-private:
-HeightMap* hmref;
-VertexArrayModel* highResModel;
-VertexArrayModel* lowResModel;
-int highRes;
-int lowRes;
-void load(int i1, int j1, int i2, int i2, HeightMap* hm, VertexArrayModel* model, int Res);
+
+  public:
+    float x;
+    float z;
+
+
+  private:
+    HeightMap*                                 hmref;                             //!<
+    VertexArrayModel*                          highResModel;                      //!<
+    VertexArrayModel*                          lowResModel;                       //!<
+    int                                        highRes;                           //!<
+    int                                        lowRes;                            //!<
 };
 
+
+//!< the height map representation itself
 class HeightMap : public VertexArrayModel
 {
-public:
-void draw();
-void load();
-void load(int Mode);
-void load(const std::string&, int Mode);
-void scale( Vector V);
-void setAbsCoor(Vector V);
-float getHeight(float x, float y);
-float getNormal(float x, float y);
-HeightMap();
-HeightMap(const std::string&);
-HeightMap(const std::string&, const std::string&);
-virtual ~HeightMap();
+  friend class Tile;
 
-friend class Tile;
+  public:
+    HeightMap();
+    HeightMap(const std::string&);
+    HeightMap(const std::string&, const std::string&);
+    virtual ~HeightMap();
 
-private:
-SDL_Surface* heightMap;
-SDL_Surface* colourMap;
-unsigned char* heights;
-unsigned char* colours;
+    void setAbsCoor(Vector V);
+    float getHeight(float x, float y);
+    float getNormal(float x, float y);
 
-void generateNormalVectorField();
-void drawRect(int xBottomLeft, int yBottomLeft, int xTopRight, int yTopRight );
-void fixBoarder(int xBottomLeft, int yBottomLeft, int xTopRight, int yTopRight);
-Vector  **  normalVectorField ;
-Tile    ***  tiles;
-Vector    camCoords;
-Vector offsetCoords;
-Material * tmp_mat;
-Material* red_mat;
-Texture* texture;
-const PNode* camera;
-float scaleX ;
-float scaleY ;
-float scaleZ ;
-float shiftX ; // to be removed
-float shiftY ; // to be removed
-float shiftZ ; // to be removed
-float offsetX;
-float offsetY;
-float offsetZ;
-int   cmScaleX;
-int   cmScaleY;
-bool  hasColourMap;
+    void load();
+    void load(int Mode);
+    void load(const std::string&, int Mode);
+    void scale( Vector V);
 
-inline int abs(int val)
-{
- if(val < 0) val = -val;
- return val;
-}
-inline int max(int x, int y)
-{
- return (x>y)? x:y;
-}
-inline int min(int x, int y)
-{
-return (x<y)? x: y;
-}
+    void draw();
+
+
+  private:
+    void generateNormalVectorField();
+    void drawRect(int xBottomLeft, int yBottomLeft, int xTopRight, int yTopRight );
+    void fixBoarder(int xBottomLeft, int yBottomLeft, int xTopRight, int yTopRight);
+
+    /** helper function absolute value @param val value*/
+    inline int abs(int val) { return (val<0)?-val:val; }
+    /** returns the max of two numbers @param x value 1 @param y value 2*/
+    inline int max(int x, int y) { return (x>y)? x:y; }
+    /** returns the min of two numbers @param x value 1 @param y value 2*/
+    inline int min(int x, int y) { return (x<y)? x: y; }
+
+
+  private:
+    SDL_Surface*                          heightMap;
+    SDL_Surface*                          colourMap;
+    unsigned char*                        heights;
+    unsigned char*                        colours;
+
+    Vector**                              normalVectorField;
+    Tile***                               tiles;
+    Vector                                camCoords;
+    Vector                                offsetCoords;
+    Material*                             tmp_mat;
+    Material*                             red_mat;
+    Texture*                              texture;
+    const PNode*                          camera;
+
+    float                                 scaleX ;
+    float                                 scaleY ;
+    float                                 scaleZ ;
+    float                                 shiftX ; // to be removed
+    float                                 shiftY ; // to be removed
+    float                                 shiftZ ; // to be removed
+    float                                 offsetX;
+    float                                 offsetY;
+    float                                 offsetZ;
+    int                                   cmScaleX;
+    int                                   cmScaleY;
+    bool                                  hasColourMap;
 };
Index: trunk/src/story_entities/game_world_data.cc
===================================================================
--- trunk/src/story_entities/game_world_data.cc	(revision 7464)
+++ trunk/src/story_entities/game_world_data.cc	(revision 7466)
@@ -382,5 +382,5 @@
     PRINTF(2)("creating %s\n", element->Value());
     BaseObject* created = Factory::fabricate(element);
-    if (created != NULL /*&& created->isA(CL_GAME_RULES)*/)
+    if (created != NULL && created->isA(CL_GAME_RULES))
     {
       this->gameRule = dynamic_cast<GameRules*>(created);
Index: trunk/src/util/kill_target.cc
===================================================================
--- trunk/src/util/kill_target.cc	(revision 7464)
+++ trunk/src/util/kill_target.cc	(revision 7466)
@@ -61,4 +61,10 @@
 
 MissionState KillTarget::checkMissionGoal(float dt)
-{}
+{
 
+}
+
+
+
+
+