Index: branches/qt_gui/src/lib/gui/qt_gui/qt_gui.h
===================================================================
--- branches/qt_gui/src/lib/gui/qt_gui/qt_gui.h	(revision 7471)
+++ branches/qt_gui/src/lib/gui/qt_gui/qt_gui.h	(revision 7472)
@@ -7,130 +7,9 @@
 #define __QT_GUI_H
 
-#include "base_object.h"
-#include "../gui_saveable.h"
+#include "../gui.h"
 #include <list>
-
-// grouping
-#include <qgroupbox.h>
-#include <qprogressbar.h>
-#include <qlabel.h>
-
-// events
-#include <qpushbutton.h>
-
-// options
-#include <qcheckbox.h>
-#include <qslider.h>
-#include <qlineedit.h>
 
 namespace OrxGui
 {
-
-  class QtGuiWidget : virtual public BaseObject
-  {
-  public:
-  };
-
-
-  class QtGuiContainer : public QtGuiWidget
-  {
-  public:
-    virtual bool pack(QtGuiWidget* widget) = 0;
-
-  protected:
-    QtGuiContainer();
-    ~QtGuiContainer();
-
-  private:
-
-  };
-
-
-  typedef enum Orientation
-  {
-    horizontal,
-    vertical
-  };
-
-  class QtGuiBox : public QtGuiContainer, public GuiSaveableGroup
-  {
-
-  public:
-    QtGuiBox(Orientation orientation);
-    ~QtGuiBox();
-
-    virtual bool pack(QtGuiWidget* widget);
-
-  private:
-    std::list<QtGuiWidget*>   children;
-
-  };
-
-  class QtGuiGroupBox : public QtGuiContainer, public GuiSaveableGroup
-  {
-  public:
-    QtGuiGroupBox(const std::string& groupName);
-    ~QtGuiGroupBox();
-
-    virtual bool pack(QtGuiWidget* widget);
-
-  private:
-    QtGuiWidget*              child;
-  };
-
-
-
-  class QtGuiCheckBox : public QCheckBox, public QtGuiWidget, public GuiSaveable
-  {
-  public:
-    QtGuiCheckBox(const std::string& name, bool defaultValue = false);
-    ~QtGuiCheckBox();
-
-  public slots:
-    void setCheckValue(int);
-
-  signals:
-    void checkValueChanged();
-  };
-
-
-  class QtGuiPushButtom : public QPushButton, public QtGuiWidget
-  {
-  public:
-    QtGuiPushButtom();
-    ~QtGuiPushButtom();
-  };
-
-  class QtGuiSlider : public QSlider, public QtGuiWidget, public GuiSaveable
-  {
-  public:
-    QtGuiSlider();
-    ~QtGuiSlider();
-
-  public slots:
-    void setSliderValue(float);
-
-  signals:
-    void sliderValueChanged(float);
-  };
-
-  class QtGuiTextLine : public QLineEdit, public QtGuiWidget, public GuiSaveable
-  {
-  public:
-    QtGuiTextLine();
-    ~QtGuiTextLine();
-
-  public slots:
-    void setTextLineValue(const char*);
-  signals:
-    void textLineChanged(const char*);
-  };
-
-
-
-  class QtGuiImage : public QtGuiWidget
-  {
-  }
-  ;
 }
 
Index: branches/qt_gui/src/lib/gui/qt_gui/qt_gui_element.cc
===================================================================
--- branches/qt_gui/src/lib/gui/qt_gui/qt_gui_element.cc	(revision 7471)
+++ 	(revision )
@@ -1,25 +1,0 @@
-/*
-   orxonox - the future of 3D-vertical-scrollers
-
-   Copyright (C) 2004 orx
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   ### File Specific:
-   main-programmer: Benjamin Grauer
-   co-programmer: ...
-*/
-
-//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
-
-#include "qt_gui.h"
-
-namespace OrxGui
-{
-
-
-
-}
Index: branches/qt_gui/src/lib/gui/qt_gui/qt_gui_elements.cc
===================================================================
--- branches/qt_gui/src/lib/gui/qt_gui/qt_gui_elements.cc	(revision 7472)
+++ branches/qt_gui/src/lib/gui/qt_gui/qt_gui_elements.cc	(revision 7472)
@@ -0,0 +1,25 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "qt_gui.h"
+
+namespace OrxGui
+{
+
+
+
+}
Index: branches/qt_gui/src/lib/gui/qt_gui/qt_gui_elements.h
===================================================================
--- branches/qt_gui/src/lib/gui/qt_gui/qt_gui_elements.h	(revision 7471)
+++ branches/qt_gui/src/lib/gui/qt_gui/qt_gui_elements.h	(revision 7472)
@@ -1,9 +1,9 @@
 /*!
- * @file qt_gui.h
+ * @file qt_gui_elements.h
  * @brief Definition of ...
 */
 
-#ifndef __QT_GUI_H
-#define __QT_GUI_H
+#ifndef __QT_GUI_ELEMENTS_H
+#define __QT_GUI_ELEMENTS_H
 
 #include "base_object.h"
@@ -135,3 +135,3 @@
 }
 
-#endif /* __QT_GUI_H */
+#endif /* __QT_GUI_ELEMENTS_H */