Index: branches/qt_gui/src/lib/gui/gui_element.cc
===================================================================
--- branches/qt_gui/src/lib/gui/gui_element.cc	(revision 7476)
+++ branches/qt_gui/src/lib/gui/gui_element.cc	(revision 7478)
@@ -27,7 +27,8 @@
    *  standard constructor
    */
-  GuiElement::GuiElement ()
+  GuiElement::GuiElement (const std::string& name)
+  : GuiSaveableGroup(name)
   {
-    this->mainWidget = NULL;
+    //this->mainWidget = NULL;
   }
 
Index: branches/qt_gui/src/lib/gui/gui_element.h
===================================================================
--- branches/qt_gui/src/lib/gui/gui_element.h	(revision 7476)
+++ branches/qt_gui/src/lib/gui/gui_element.h	(revision 7478)
@@ -8,4 +8,6 @@
 #define _GUI_ELEMENT_H
 
+#include "gui_saveable.h"
+
 namespace OrxGui
 {
@@ -13,9 +15,9 @@
 
   //! A SuperClass for all the Different GuiElements
-  class GuiElement
+  class GuiElement : public GuiSaveableGroup
   {
 
   public:
-    GuiElement();
+    GuiElement(const std::string& name);
     virtual ~GuiElement();
 
Index: branches/qt_gui/src/lib/gui/gui_saveable.cc
===================================================================
--- branches/qt_gui/src/lib/gui/gui_saveable.cc	(revision 7476)
+++ branches/qt_gui/src/lib/gui/gui_saveable.cc	(revision 7478)
@@ -49,5 +49,5 @@
       : GuiSaveable(groupName)
   {
-//    this->setName(groupName);
+    //    this->setName(groupName);
   }
 
Index: branches/qt_gui/src/lib/gui/gui_saveable.h
===================================================================
--- branches/qt_gui/src/lib/gui/gui_saveable.h	(revision 7476)
+++ branches/qt_gui/src/lib/gui/gui_saveable.h	(revision 7478)
@@ -12,49 +12,49 @@
 
 // FORWARD DECLARATION
-  namespace OrxGui
+namespace OrxGui
+{
+  //! A class for ...
+  class GuiSaveable
   {
-    //! A class for ...
-    class GuiSaveable
-    {
-    public:
-    protected:
-      GuiSaveable(const std::string& optionName);
-      virtual ~GuiSaveable();
+  public:
+    virtual ~GuiSaveable();
 
-      void makeSaveable();
+    void makeSaveable();
 
-      virtual void load(const MultiType& value) = 0;
-      virtual const MultiType& save() = 0;
+    virtual void load(const MultiType& value) = 0;
+    virtual const MultiType& save() = 0;
 
-      MultiType&       getValue() { return this->value; };
-      const MultiType& getValue() const { return this->value; };
-      bool             isSaveable() const { return this->bSaveable; };
+    MultiType&       getValue() { return this->value; };
+    const MultiType& getValue() const { return this->value; };
+    bool             isSaveable() const { return this->bSaveable; };
 
-    protected:
-      virtual void makingElementSaveable() {};
+  protected:
+    GuiSaveable(const std::string& optionName);
+    virtual void makingElementSaveable() {};
 
-    private:
-      MultiType       value;
-      bool            bSaveable;
-    };
+  private:
+    MultiType       value;
+    bool            bSaveable;
+  };
 
 
 
-    class GuiSaveableGroup : virtual public GuiSaveable
-    {
-    public:
-      GuiSaveableGroup(const std::string& name);
-      ~GuiSaveableGroup();
+  class GuiSaveableGroup : public GuiSaveable
+  {
+  public:
+    virtual ~GuiSaveableGroup();
 
-      void addSaveable(GuiSaveable* saveable);
-      void removeSaveable(GuiSaveable* saveable);
+    void addSaveable(GuiSaveable* saveable);
+    void removeSaveable(GuiSaveable* saveable);
 
-    protected:
-      virtual void makingElementSaveable();
-    private:
-      std::vector<GuiSaveable*>              saveables;
-      static std::vector<GuiSaveableGroup*>  saveableGroups;
-    };
+  protected:
+    GuiSaveableGroup(const std::string& name);
+    virtual void makingElementSaveable();
 
-  }
+  private:
+    std::vector<GuiSaveable*>              saveables;
+    static std::vector<GuiSaveableGroup*>  saveableGroups;
+  };
+
+}
 #endif /* _GUI_SAVEABLE_H */
Index: branches/qt_gui/src/lib/gui/qt_gui/qt_gui.cc
===================================================================
--- branches/qt_gui/src/lib/gui/qt_gui/qt_gui.cc	(revision 7476)
+++ branches/qt_gui/src/lib/gui/qt_gui/qt_gui.cc	(revision 7478)
@@ -18,7 +18,11 @@
 #include "qt_gui.h"
 
+#include <qapplication.h>
+
+
 namespace OrxGui
 {
-  QtGui::QtGui()
+  QtGui::QtGui(int argc, char** argv)
+  : QApplication(argc, argv)
   {
 
@@ -26,4 +30,5 @@
 
   }
+
   QtGui::~QtGui()
   {
@@ -42,5 +47,7 @@
     //! Update the Gui.
   void QtGui::update()
-  {}
+  {
+    this->processEvents();
+  }
 
 }
Index: branches/qt_gui/src/lib/gui/qt_gui/qt_gui.h
===================================================================
--- branches/qt_gui/src/lib/gui/qt_gui/qt_gui.h	(revision 7476)
+++ branches/qt_gui/src/lib/gui/qt_gui/qt_gui.h	(revision 7478)
@@ -9,10 +9,12 @@
 #include "../gui.h"
 #include "gui_element.h"
+#include <qapplication.h>
+
 namespace OrxGui
 {
-  class QtGui : public OrxGui::Gui
+  class QtGui : public OrxGui::Gui, QApplication
   {
     public:
-      QtGui();
+      QtGui(int argc, char** argv);
       virtual ~QtGui();
 