Index: /branches/qt_gui/src/Makefile.am
===================================================================
--- /branches/qt_gui/src/Makefile.am	(revision 7478)
+++ /branches/qt_gui/src/Makefile.am	(revision 7479)
@@ -12,6 +12,9 @@
 bin_PROGRAMS = orxonox
 
-orxonox_CPPFLAGS = -DIS_ORXONOX
-orxonox_LDFLAGS = -u global_ModelParticles_Factory
+orxonox_CPPFLAGS = \
+		-DIS_ORXONOX \
+		@QT_CXXFLAGS@
+
+orxonox_LDFLAGS =
 
 orxonox_DEPENDENCIES = \
@@ -24,5 +27,6 @@
 		util/libORXutils.a \
 		$(libORXlibs_a_LIBRARIES_) \
-		$(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS)
+		$(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS) \
+		@QT_LIBS@
 
 orxonox_SOURCES = \
@@ -63,12 +67,13 @@
 
 ## orxonox.conf will be used from home-dir instead.
-EXTRA_DIST = proto/proto_class.h \
-             proto/proto_class.cc \
-             proto/proto_singleton.h \
-             proto/proto_singleton.cc \
-             proto/proto_world_entity.h \
-             proto/proto_world_entity.cc \
-             defs/include_paths.am \
-             story_entities/Makefile.am
+EXTRA_DIST = \
+		proto/proto_class.h \
+		proto/proto_class.cc \
+		proto/proto_singleton.h \
+		proto/proto_singleton.cc \
+		proto/proto_world_entity.h \
+		proto/proto_world_entity.cc \
+		defs/include_paths.am \
+		story_entities/Makefile.am
 
 if SUB_PROJECTS
@@ -78,9 +83,10 @@
 endif
 
-SUBDIRS = lib \
-          util \
-          world_entities \
-          . \
-          $(SUB_PROGS)
+SUBDIRS = \
+		lib \
+		util \
+		world_entities \
+		. \
+		$(SUB_PROGS)
 
 
Index: /branches/qt_gui/src/lib/BuildLibs.am
===================================================================
--- /branches/qt_gui/src/lib/BuildLibs.am	(revision 7478)
+++ /branches/qt_gui/src/lib/BuildLibs.am	(revision 7479)
@@ -2,6 +2,8 @@
 libORXlibs_a_LIBRARIES_ = \
                 $(LIB_PREFIX)/libORXlibs.a \
-                $(LIB_PREFIX)/gui/gtk_gui/libORXgui.a \
+                $(LIB_PREFIX)/gui/gtk_gui/libORXgtkgui.a \
+                $(LIB_PREFIX)/gui/qt_gui/libORXqtgui.a \
                 $(LIB_PREFIX)/gui/gl_gui/libORXglgui.a \
+                $(LIB_PREFIX)/gui/libORXbasegui.a \
                 $(LIB_PREFIX)/graphics/importer/libORXimporter.a \
                 $(LIB_PREFIX)/graphics/libORXgraphics.a \
Index: /branches/qt_gui/src/lib/gui/gtk_gui/Makefile.am
===================================================================
--- /branches/qt_gui/src/lib/gui/gtk_gui/Makefile.am	(revision 7478)
+++ /branches/qt_gui/src/lib/gui/gtk_gui/Makefile.am	(revision 7479)
@@ -2,30 +2,32 @@
 include $(MAINSRCDIR)/defs/include_paths.am
 
-noinst_LIBRARIES = libORXgui.a
+noinst_LIBRARIES = libORXgtkgui.a
 
-libORXgui_a_CPPFLAGS = -DBUILD_ORXONOX \
-			$(GTK2_CFLAGS) $(GTHREAD_CFLAGS) $(CURL_CFLAGS) $(MSBITFIELDS)
+libORXgtkgui_a_CPPFLAGS = \
+		-DBUILD_ORXONOX \
+		$(GTK2_CFLAGS) $(GTHREAD_CFLAGS) $(CURL_CFLAGS) $(MSBITFIELDS)
 
-libORXgui_a_SOURCES = gui.cc \
-		      gui_gtk.cc \
-	              gui_element.cc \
-	       	      gui_video.cc \
-	              gui_audio.cc \
-	              gui_exec.cc \
-	              gui_flags.cc \
-	              gui_banner.cc \
-	              gui_keys.cc \
-	              gui_update.cc
+libORXgtkgui_a_SOURCES = \
+		gui.cc \
+		gui_gtk.cc \
+		gui_element.cc \
+		gui_video.cc \
+		gui_audio.cc \
+		gui_exec.cc \
+		gui_flags.cc \
+		gui_banner.cc \
+		gui_keys.cc \
+		gui_update.cc
 
 noinst_HEADERS= gui.h \
-	        gui_gtk.h \
-	        gui_element.h \
-	        gui_video.h \
-	        gui_audio.h \
-	        gui_exec.h \
-	        gui_flags.h \
-	        gui_banner.h \
-	        gui_keys.h \
-	        gui_update.h
+		gui_gtk.h \
+		gui_element.h \
+		gui_video.h \
+		gui_audio.h \
+		gui_exec.h \
+		gui_flags.h \
+		gui_banner.h \
+		gui_keys.h \
+		gui_update.h
 
 EXTRA_DIST = rc \
Index: /branches/qt_gui/src/lib/gui/gui_saveable.cc
===================================================================
--- /branches/qt_gui/src/lib/gui/gui_saveable.cc	(revision 7478)
+++ /branches/qt_gui/src/lib/gui/gui_saveable.cc	(revision 7479)
@@ -25,6 +25,8 @@
   */
   GuiSaveable::GuiSaveable (const std::string& optionName)
+  : BaseObject(optionName)
   {
     this->bSaveable = false;
+
   }
 
@@ -49,5 +51,4 @@
       : GuiSaveable(groupName)
   {
-    //    this->setName(groupName);
   }
 
Index: /branches/qt_gui/src/lib/gui/gui_saveable.h
===================================================================
--- /branches/qt_gui/src/lib/gui/gui_saveable.h	(revision 7478)
+++ /branches/qt_gui/src/lib/gui/gui_saveable.h	(revision 7479)
@@ -15,5 +15,5 @@
 {
   //! A class for ...
-  class GuiSaveable
+  class GuiSaveable : public BaseObject
   {
   public:
Index: /branches/qt_gui/src/lib/gui/qt_gui/qt_gui.cc
===================================================================
--- /branches/qt_gui/src/lib/gui/qt_gui/qt_gui.cc	(revision 7478)
+++ /branches/qt_gui/src/lib/gui/qt_gui/qt_gui.cc	(revision 7479)
@@ -27,4 +27,8 @@
   {
 
+    this->mainWindow = new QMainWindow();
+    this->mainWindow->show();
+
+    this->exec();
 
 
Index: /branches/qt_gui/src/lib/gui/qt_gui/qt_gui.h
===================================================================
--- /branches/qt_gui/src/lib/gui/qt_gui/qt_gui.h	(revision 7478)
+++ /branches/qt_gui/src/lib/gui/qt_gui/qt_gui.h	(revision 7479)
@@ -10,4 +10,5 @@
 #include "gui_element.h"
 #include <qapplication.h>
+#include <qmainwindow.h>
 
 namespace OrxGui
@@ -30,4 +31,5 @@
 
     private:
+      QMainWindow*              mainWindow;
       std::list<GuiElement*>    elements;   //!< A List of Elements within the QTGui
   };
Index: /branches/qt_gui/src/orxonox.cc
===================================================================
--- /branches/qt_gui/src/orxonox.cc	(revision 7478)
+++ /branches/qt_gui/src/orxonox.cc	(revision 7479)
@@ -30,5 +30,5 @@
 #include "globals.h"
 
-#include "gui.h"
+#include "gui/qt_gui/qt_gui.h"
 
 #include "parser/ini_parser/ini_parser.h"
@@ -330,5 +330,5 @@
               CONFIG_SECTION_DATA,
               CONFIG_NAME_DATADIR );
-    Gui* gui = new Gui(argc, argv);
+    OrxGui::Gui* gui = new OrxGui::QtGui(argc, argv);
     gui->startGui();
     delete gui;
@@ -497,9 +497,9 @@
 
     // starting the GUI
-    Gui* gui = new Gui(argc, argv);
+    OrxGui::Gui* gui = new OrxGui::QtGui(argc, argv);
     gui->startGui();
 
-    if (! gui->startOrxonox)
-      return 0;
+//    if (!gui->startOrxonox)
+//      return 0;
 
     delete gui;